package cokr.xit.fims.excl.service.bean;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Component;

import cokr.xit.foundation.component.AbstractBean;
import cokr.xit.foundation.data.DataObject;
import cokr.xit.fims.cmmn.CmmnUtil;
import cokr.xit.fims.excl.LevyExclQuery;
import cokr.xit.fims.excl.OpnnDlbrMbr;
import cokr.xit.fims.excl.dao.OpnnDlbrMbrMapper;

/**의견제출 심의 회원 정보 관리 Bean
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2024-05-17	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Component("opnnDlbrMbrBean")
public class OpnnDlbrMbrBean extends AbstractBean {

	/** 의견제출 심의 회원 정보 DAO */
	@Resource(name = "opnnDlbrMbrMapper")
	private OpnnDlbrMbrMapper opnnDlbrMbrMapper;

	/**지정한 조건에 따라 의견제출 심의 회원 목록을 조회하여 반환한다.
	 * @param req 의견제출 대장 조회 조건
	 * @return 의견제출 심의 회원 목록
	 */
	public List<DataObject> getOpnnDlbrMbrList(LevyExclQuery req) {
		// 삭제 여부 확인
		if (req.getDelYn() == null) {
			req.setDelYn("N");
		}
		// 정렬 확인
		if (req.getOrderBy() == null) {
			if (req.getBy() == null) {
				req.setOrderBy("REG_DT");
			} else {
				req.setOrderBy(CmmnUtil.convertCamelCaseToSnakeCase(req.getBy()));
			}
		}

		return opnnDlbrMbrMapper.selectOpnnDlbrMbrList(req);
	}

	/**지정한 조건에 따라 의견제출 심의 회원 객체들을 반환한다.
	 * @param req 의견제출 대장 조회 조건
	 * @return 의견제출 심의 회원 객체 목록
	 */
	public List<DataObject> getOpnnDlbrMbrs(LevyExclQuery req) {
		// 삭제 여부 확인
		if (req.getDelYn() == null) {
			req.setDelYn("N");
		}
		// 정렬 확인
		if (req.getOrderBy() == null) {
			req.setOrderBy("REG_DT");
		}

		return opnnDlbrMbrMapper.selectOpnnDlbrMbrs(req);
	}

	/**지정한 조건에 따라 의견제출 심의 회원 정보를 반환한다.
	 * @param req 의견제출 대장 조회 조건
	 * @return 의견제출 정보
	 */
	public DataObject getOpnnDlbrMbrInfo(LevyExclQuery req) {
		return opnnDlbrMbrMapper.selectOpnnDlbrMbrInfo(req);
	}

	/**의견제출 심의 회원 정보를 등록한다.
	 * @param opnnDlbrMbr 의견제출 심의 회원
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public String createOpnnDlbrMbr(OpnnDlbrMbr opnnDlbrMbr) {
		// 의견제출 심의 회원 정보를 등록한다.
		int rtnNocs = opnnDlbrMbrMapper.insertOpnnDlbrMbr(opnnDlbrMbr);
		if (rtnNocs != 1) {
			throw new RuntimeException("의견제출 심의의원 등록에 실패하였습니다.");	// 예외를 발생시켜서 DB Rollback
		}

		return "[S] 작업이 정상 처리 되었습니다.";
	}

	/**의견제출 심의 회원 정보를 수정한다.
	 * @param opnnDlbrMbr 의견제출 심의 회원
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public String updateOpnnDlbrMbr(OpnnDlbrMbr opnnDlbrMbr) {
		// 의견제출 심의 회원 정보를 수정한다.
		int rtnNocs = opnnDlbrMbrMapper.updateOpnnDlbrMbr(opnnDlbrMbr);
		if (rtnNocs != 1) {
			throw new RuntimeException("의견제출 심의의원 수정에 실패하였습니다.");	// 예외를 발생시켜서 DB Rollback
		}

		return "[S] 작업이 정상 처리 되었습니다.";
	}

}
